diff --git a/arch/arm/mm/dma-mapping.c b/arch/arm/mm/dma-mapping.c
index e822af0d9219..5cd122b9e7d0 100644
--- a/arch/arm/mm/dma-mapping.c
+++ b/arch/arm/mm/dma-mapping.c
@@ -118,6 +118,7 @@ static void __dma_page_dev_to_cpu(struct page *, unsigned long,
  * @offset: offset into page for start of buffer
  * @size: size of buffer to map
  * @dir: DMA transfer direction
+ * @attrs: DMA attributes
  *
  * Ensure that any data held in the cache is appropriately discarded
  * or written back.
@@ -147,6 +148,7 @@ static dma_addr_t arm_coherent_dma_map_page(struct device *dev, struct page *pag
  * @handle: DMA address of buffer
  * @size: size of buffer (same as passed to dma_map_page)
  * @dir: DMA transfer direction (same as passed to dma_map_page)
+ * @attrs: DMA attributes
  *
  * Unmap a page streaming mode DMA translation.  The handle and size
  * must match what was provided in the previous dma_map_page() call.
@@ -993,6 +995,7 @@ static void __dma_page_dev_to_cpu(struct page *page, unsigned long off,
  * @sg: list of buffers
  * @nents: number of buffers to map
  * @dir: DMA transfer direction
+ * @attrs: DMA attributes
  *
  * Map a set of buffers described by scatterlist in streaming mode for DMA.
  * This is the scatter-gather version of the dma_map_single interface.
@@ -1033,6 +1036,7 @@ int arm_dma_map_sg(struct device *dev, struct scatterlist *sg, int nents,
  * @sg: list of buffers
  * @nents: number of buffers to unmap (same as was passed to dma_map_sg)
  * @dir: DMA transfer direction (same as was passed to dma_map_sg)
+ * @attrs: DMA attributes
  *
  * Unmap a set of streaming mode DMA translations.  Again, CPU access
  * rules concerning calls here are the same as for dma_unmap_single().
@@ -1708,6 +1712,7 @@ static int __iommu_map_sg(struct device *dev, struct scatterlist *sg, int nents,
  * @sg: list of buffers
  * @nents: number of buffers to map
  * @dir: DMA transfer direction
+ * @attrs: DMA attributes
  *
  * Map a set of i/o coherent buffers described by scatterlist in streaming
  * mode for DMA. The scatter gather list elements are merged together (if
@@ -1726,6 +1731,7 @@ static int arm_coherent_iommu_map_sg(struct device *dev, struct scatterlist *sg,
  * @sg: list of buffers
  * @nents: number of buffers to map
  * @dir: DMA transfer direction
+ * @attrs: DMA attributes
  *
  * Map a set of buffers described by scatterlist in streaming mode for DMA.
  * The scatter gather list elements are merged together (if possible) and
@@ -1761,6 +1767,7 @@ static void __iommu_unmap_sg(struct device *dev, struct scatterlist *sg,
  * @sg: list of buffers
  * @nents: number of buffers to unmap (same as was passed to dma_map_sg)
  * @dir: DMA transfer direction (same as was passed to dma_map_sg)
+ * @attrs: DMA attributes
  *
  * Unmap a set of streaming mode DMA translations.  Again, CPU access
  * rules concerning calls here are the same as for dma_unmap_single().
@@ -1778,6 +1785,7 @@ static void arm_coherent_iommu_unmap_sg(struct device *dev,
  * @sg: list of buffers
  * @nents: number of buffers to unmap (same as was passed to dma_map_sg)
  * @dir: DMA transfer direction (same as was passed to dma_map_sg)
+ * @attrs: DMA attributes
  *
  * Unmap a set of streaming mode DMA translations.  Again, CPU access
  * rules concerning calls here are the same as for dma_unmap_single().
@@ -1835,6 +1843,7 @@ static void arm_iommu_sync_sg_for_device(struct device *dev,
  * @offset: offset into page for start of buffer
  * @size: size of buffer to map
  * @dir: DMA transfer direction
+ * @attrs: DMA attributes
  *
  * Coherent IOMMU aware version of arm_dma_map_page()
  */
@@ -1869,6 +1878,7 @@ static dma_addr_t arm_coherent_iommu_map_page(struct device *dev, struct page *p
  * @offset: offset into page for start of buffer
  * @size: size of buffer to map
  * @dir: DMA transfer direction
+ * @attrs: DMA attributes
  *
  * IOMMU aware version of arm_dma_map_page()
  */
@@ -1888,6 +1898,7 @@ static dma_addr_t arm_iommu_map_page(struct device *dev, struct page *page,
  * @handle: DMA address of buffer
  * @size: size of buffer (same as passed to dma_map_page)
  * @dir: DMA transfer direction (same as passed to dma_map_page)
+ * @attrs: DMA attributes
  *
  * Coherent IOMMU aware version of arm_dma_unmap_page()
  */
@@ -1912,6 +1923,7 @@ static void arm_coherent_iommu_unmap_page(struct device *dev, dma_addr_t handle,
  * @handle: DMA address of buffer
  * @size: size of buffer (same as passed to dma_map_page)
  * @dir: DMA transfer direction (same as passed to dma_map_page)
+ * @attrs: DMA attributes
  *
  * IOMMU aware version of arm_dma_unmap_page()
  */
@@ -1940,6 +1952,7 @@ static void arm_iommu_unmap_page(struct device *dev, dma_addr_t handle,
  * @phys_addr: physical address of resource
  * @size: size of resource to map
  * @dir: DMA transfer direction
+ * @attrs: DMA attributes
  */
 static dma_addr_t arm_iommu_map_resource(struct device *dev,
 		phys_addr_t phys_addr, size_t size,
@@ -1974,6 +1987,7 @@ static dma_addr_t arm_iommu_map_resource(struct device *dev,
  * @dma_handle: DMA address to resource
  * @size: size of resource to map
  * @dir: DMA transfer direction
+ * @attrs: DMA attributes
  */
 static void arm_iommu_unmap_resource(struct device *dev, dma_addr_t dma_handle,
 		size_t size, enum dma_data_direction dir,